import { call, put, select } from 'redux-saga/effects';
import QueryString from 'query-string'


import * as api from '../../../constants/api';
import * as request from '../../../utils/request';

import {
  {{ camelCase name }}SetLoading,
  {{ camelCase name }}Merge
} from '../actions' 
import { makeSelect{{ properCase name }} } from '../selectors';

export default function* fetch(action) {
  const { query = {}, onSuccess = () => { }, onError = () => { } } = action.payload;

  try {
    yield put({{ camelCase name }}SetLoading(true))
    const state = yield select(makeSelect{{ properCase name }}())

    const queryString = QueryString.stringify(query, { skipNull: true })
    const url = `${api.url}?${queryString || state.queryString}`

    const { data } = yield call(request.get, url); 
    
    yield put(
      {{ camelCase name }}Merge({
        records: data,
        isLoading: false,
        isUpdated: true,
        queryString
      }),
    )
    yield call(onSuccess, data)
  } catch (err) {
    yield call(onError, err.message);
  } finally {
    yield put({{ camelCase name }}SetLoading(false))
  }
}
